Difference between revisions of "RPi Kernel Compilation"

From eLinux.org
Jump to: navigation, search
(re order)
m (Get the kernel source)
(21 intermediate revisions by 9 users not shown)
Line 1: Line 1:
 
{{Template:RPi_Software}}
 
{{Template:RPi_Software}}
 +
 
= Overview =
 
= Overview =
First, you are going to get and build the linux kernel and its modules using a suitable compiler (a "cross-compiler" if you aren't building it on the same hardware you will be running it on) and then you are going to create a kernel image from the uncompressed kernel (Image) to place on the sd, along with the modules you build alongside it.
+
This page explains how to rebuild the kernel image for the RPi. There are two possible routes available:
= From the Raspberry pi =
+
# Compile on the Raspberry Pi itself
== Firmware ==
+
# Cross compile on another Linux system
cd /opt
+
 
git clone --depth 1 git://github.com/raspberrypi/firmware.git
+
Both of these routes are covered below, however, you are strongly recommended to follow the cross compilation route. The low processing power of the RPi means that a local compile will take many hours.
cd firmware/boot
+
 
cp arm128_start.elf arm192_start.elf arm224_start.elf bootcode.bin loader.bin start.elf /boot/
+
= Get the kernel source =
cd /opt
+
The kernel source should be downloaded from the [https://github.com/raspberrypi/linux RPI linux section on GitHub]. Although you could just compile the vanilla kernel from [http://www.kernel.org/ Kernel.org], it will not have the necessary drivers and modules for the Broadcom SoC on the RPi. You can however apply patches from the vanilla kernel to the RPi one - be prepared for potential compiler grumbles though!
rm -r firmware
+
 
== Kernel compilation ==
+
At the time of writing, two branches of interest are available:
=== Debian pre-build===
+
* '''rpi-3.2.27''' - This is the version of the kernel currently used in Raspbian.
apt-get update
+
* '''rpi-3.6-y''' - This is a development branch based on the current vanilla kernel. It will eventually replace the 3.2 branch.
apt-get -y dist-upgrade
+
 
apt-get -y install git gcc make tmux
+
You can download the source directly using git. For the 3.2 branch:
=== Arch Linux pre-build===
+
<pre>
pacman -Syu
+
git clone git://github.com/raspberrypi/linux.git
pacman -S git gcc make tmux
+
</pre>
=== Common ===
+
and for the 3.6 branch:
cd /opt
+
<pre>
mkdir raspberrypi
+
git fetch git://github.com/raspberrypi/linux.git rpi-3.6.y:refs/remotes/origin/rpi-3.6.y
cd raspberrypi
+
git checkout rpi-3.6.y
git clone --depth 1 git://github.com/raspberrypi/linux.git
+
</pre>
cd linux
+
Or you can download a tarball from the website using these links: [https://github.com/raspberrypi/linux/archive/rpi-3.2.27.tar.gz rpi-3.2.27] [https://github.com/raspberrypi/linux/archive/rpi-3.6.y.tar.gz rpi-3.6.y]
zcat /proc/config.gz > .config
+
 
#optional#make menuconfig
+
= Get a compiler =
tmux new -s make
+
Next, you will need to get a version of GCC in order to build the kernel.
nice make; nice make modules
+
 
[Ctrl]+[B],[D]
+
== On the RPi ==
############## … 5 hours later ...
+
 
tmux a -t m
+
=== Raspbian ===
[Ctrl]+[D]
+
<pre>
cp arch/arm/boot/Image /boot/kernel.img
+
apt-get update
make ARCH=arm modules_install INSTALL_MOD_PATH=/
+
apt-get -y dist-upgrade
cd /opt
+
apt-get -y install gcc make
rm -r raspberrypi
+
</pre>
shutdown -r now;
+
 
= From a foreign machine =
+
=== Arch Linux ===
== Firmware ==
+
<pre>
cd /opt
+
pacman -Syu
git clone git://github.com/raspberrypi/firmware.git
+
pacman -S gcc make
cd firmware/boot
+
</pre>
scp arm128_start.elf arm192_start.elf arm224_start.elf bootcode.bin loader.bin start.elf <user>@<host>:/boot/
+
 
After the first time:
+
== Cross compiling from Linux ==
cd /opt/firmware
+
Please note that when cross-compiling, your compiler may not target the correct ARM processor by default. This will at best reduce performance, or worse, compile for a much newer processor resulting in illegal instructions in your code. The pre-built compiler or a custom-built compiler are recommended because of this. (For example, the latest GCC Linaro binary targets armv7-a by default, whereas the RPi requires armv6kz). It is possible to add extra compiler options to the <tt>HOSTCFLAGS</tt> line in <tt>Makefile</tt>. The correct flags are shown on the [[RPi_Software#Compiler|software page]] - note that you may also need to add <tt>-marm</tt> if your compiler produces Thumb code by default.
git pull
+
 
cd boot
+
=== Use the provided compiler ===
scp arm128_start.elf arm192_start.elf arm224_start.elf bootcode.bin loader.bin start.elf <user>@<host>:/boot/
+
Download the pre-built bmc2708 compiler from the [https://github.com/raspberrypi/tools/tree/master/arm-bcm2708/arm-bcm2708hardfp-linux-gnueabi RPI tools section on GitHub].
== Kernel compilation ==
+
<pre>
You can use the "-j" flag to improve compilation time. If you have a dual core machine you can use "-j 3", for a quad core machine you can use "-j 6", and so on.
+
git clone git://github.com/raspberrypi/tools.git
=== Ubunt ===
+
</pre>
apt-get install git gcc-arm-linux-gnueabi make ncurses-dev
+
or you can download a tarball from the website using [https://github.com/raspberrypi/tools/archive/master.tar.gz this link].
cd /opt
+
 
mkdir raspberrypi
+
=== Custom-built Linaro GCC ===
cd raspberrypi
+
See [[RPi_Linaro_GCC_Compilation|Linaro GCC Compilation]].
git clone git://github.com/raspberrypi/linux.git
+
 
cd linux
+
=== Ubuntu ===
cp arch/arm/configs/bcmrpi_cutdown_defconfig .config
+
<pre>
make ARCH=arm CROSS_COMPILE=/usr/bin/arm-linux-gnueabi- oldconfig
+
apt-get install gcc-arm-linux-gnueabi make ncurses-dev
#optional#make ARCH=arm CROSS_COMPILE=/usr/bin/arm-linux-gnueabi- menuconfig
+
</pre>
make ARCH=arm CROSS_COMPILE=/usr/bin/arm-linux-gnueabi- -k
+
 
 
=== Gentoo Linux ===
 
=== Gentoo Linux ===
==== getting the compiler ====
+
<pre>
Build the cross toolchain:
+
crossdev -S -v -t arm-unknown-linux-gnueabi
crossdev -S -v -t arm-unknown-linux-gnueabi
+
</pre>
theBuell: on 2012-05-06, cross -S -v -A gnueabi arm works just fine
+
 
 +
Crossdev should create a cross-toolchain using the latest stable versions of the required packages.  If it fails, you can specify exact versions by removing the "-S" flag and adding the "--b", "--g", "--k" and "--l" flags. On 2012-05-06, <tt>cross -S -v -A gnueabi arm</tt> works just fine.
  
This command should create a cross-toolchain using the latest stable versions of the required packages.  If it fails, you can specify exact versions by removing the "-S" flag and adding the "--b", "--g", "--k" and "--l" flags. For the exact usage refer to the crossdev manpage. A good starting point for figuring out the right versions are those which are stable for the arm architecture.
 
==== getting the sources ====
 
create a directory where you can work on  the raspberry pi software. I called mine "raspberrypi". Then clone the git repository.
 
mkdir raspberrypi
 
cd raspberrypi
 
git clone https://github.com/raspberrypi/linux.git
 
cd linux
 
==== compiling ====
 
Next you have to configure the kernel:
 
cp arch/arm/configs/bcmrpi_cutdown_defconfig .config
 
make ARCH=arm CROSS_COMPILE=/usr/bin/arm-linux-gnueabi- oldconfig
 
Then building the kernel:
 
make ARCH=arm CROSS_COMPILE=/usr/bin/arm-linux-gnueabi- -k
 
You can use the "-j" flag to improve compilation time. If you have a dual core machine you can use "-j 3", for a quad core machine you can use "-j 6", and so on.
 
 
=== Arch Linux ===
 
=== Arch Linux ===
==== getting the compiler ====
+
<pre>
You will need GIT to clone the kernel source tree from GitHub:
+
yaourt -S arm-linux-gnueabi-gcc
pacman -S git
+
</pre>
Build the cross toolchain:
+
 
arm-linux-gnueabi-gcc is on the AUR. If you use yaourt:
+
== Cross compiling from OSX ==
yaourt -S arm-linux-gnueabi-gcc
+
=== Macports ===
Yaourt is recommended as it will build all dependencies.
+
==== getting the sources ====
+
create a directory where you can work on  the raspberry pi software. I called mine "raspberrypi". Then clone the git repository.
+
mkdir raspberrypi
+
cd raspberrypi
+
git clone https://github.com/raspberrypi/linux.git
+
cd linux
+
==== compiling ====
+
Next you have to configure the kernel:
+
cp arch/arm/configs/bcmrpi_cutdown_defconfig .config
+
make ARCH=arm CROSS_COMPILE=/usr/bin/arm-linux-gnueabi- oldconfig
+
Then building the kernel:
+
make ARCH=arm CROSS_COMPILE=/usr/bin/arm-linux-gnueabi- -k
+
You can use the "-j" flag to improve compilation time. If you have a dual core machine you can use "-j 3", for a quad core machine you can use "-j 6", and so on.
+
=== OS X ===
+
 
The Kernel source requires a case-sensitive filesystem. If you do not have a HFS+ Case-sensitive partition that can be used, create a disk image with the appropriate format.
 
The Kernel source requires a case-sensitive filesystem. If you do not have a HFS+ Case-sensitive partition that can be used, create a disk image with the appropriate format.
Ensure latest Xcode and command line tools are installed from [http://developer.apple.com/downloads Apple Developer Connection]  
+
Ensure latest Xcode and command line tools are installed from [http://developer.apple.com/downloads Apple Developer Connection]
==== Yagarto ====
+
Install [http://guide.macports.org/#installing macports]
Downoad and install an GNU ARM toolchain such as [http://www.yagarto.de/#downloadmac yagarto].
+
<pre>
==== Macports ====
+
port install arm-none-eabi-gcc
[http://guide.macports.org/#installing macports]
+
port install arm-none-eabi-binutils
port install arm-none-eabi-gcc
+
</pre>
port install arm-none-eabi-binutils
+
 
==== Common ====
+
cd /opt
+
mkdir raspberrypi
+
cd raspberrypi
+
git clone git://github.com/raspberrypi/linux.git
+
cd linux
+
cp arch/arm/configs/bcmrpi_cutdown_defconfig .config
+
==== Yagarto ====
+
make ARCH=arm CROSS_COMPILE=/path/to/yagarto/bin/arm-none-eabi- oldconfig
+
make ARCH=arm CROSS_COMPILE=/path/to/yagarto/bin/arm-none-eabi- -k
+
==== Macports ====
+
make ARCH=arm CROSS_COMPILE=/opt/local/bin/arm-none-eabi- oldconfig
+
make ARCH=arm CROSS_COMPILE=/opt/local/bin/arm-none-eabi- -k
+
 
'''If you get an error message that elf.h is missing'''
 
'''If you get an error message that elf.h is missing'''
 
  sudo port install libelf && sudo ln -s /opt/local/include/libelf /usr/include/libelf
 
  sudo port install libelf && sudo ln -s /opt/local/include/libelf /usr/include/libelf
copy [http://opensource.apple.com/source/dtrace/dtrace-48/sys/elf.h?txt elf.h] and [http://opensource.apple.com/source/dtrace/dtrace-48/sys/elftypes.h?txt elftypes.h] to /usr/include
+
From opensource.apple.com, download and copy [http://opensource.apple.com/source/dtrace/dtrace-48/sys/elf.h?txt elf.h] and [http://opensource.apple.com/source/dtrace/dtrace-48/sys/elftypes.h?txt elftypes.h] to /usr/include
 +
 
 
Edit elf.h and add
 
Edit elf.h and add
 
  #define R_386_NONE        0
 
  #define R_386_NONE        0
Line 146: Line 107:
 
to
 
to
 
  NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include) -Dlinux
 
  NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include) -Dlinux
== Transferring The Build ==
 
Then you have to transfer this img file to the /boot directory and install the compiled modules. Unfortunately the compiled modules are not in a single place, there are two options of installing them.
 
  
Boot your RaspberryPi and mount the <code>linux</code> directory over the network using sshfs:
+
=== Yagarto ===
cd /mnt
+
Download and install from [http://www.yagarto.de/#downloadmac here].
mkdir linux
+
 
sshfs <user>@<host>:<path/to/linux> linux
+
= Perform the compilation =
cd linux
+
Firstly, ensure your build directory is clean:
make install
+
<pre>
make modules_install
+
make mrproper
If you got "Permission denied" when doing <code>cd linux</code>, try:
+
</pre>
sudo sh -c "cd linux ; make modules_install"
+
 
If that is not an option, you can also install the modules into a temporary folder:
+
Next, in all cases, you will want to get a working kernel configuration to start from. You can get the one running on the RPi by typing the following (on the RPi):
mkdir /tmp/modules
+
<pre>
make ARCH=arm modules_install INSTALL_MOD_PATH=/tmp/modules
+
zcat /proc/config.gz > .config
Now you have to copy the contents of that directory to /lib/modules on the SD card.
+
</pre>
scp linux/arch/arm/boot/Image <user>@<host>:/boot/kernel.img
+
then copy <tt>.config</tt> into your build directory.
scp -r /tmp/modules/* <user>@<host>://lib/modules/
+
 
Once you've done those two steps, you are ready to put the SD card in and try booting your new system!
+
Alternatively, the default configuration is available in the downloaded kernel source in <tt>arch/arm/configs/bcmrpi_defconfig</tt>. Just copy this to <tt>.config</tt> in the build directory.
=References=
+
 
<references/>
+
From this point on, if you are cross-compiling, please substitute <tt><your_compiler></tt> with your compiler binary prefix (e.g. <tt>arm-bcm2708hardfp-linux-gnueabi-</tt>) as each compiler will be named slightly differently. If you are building on the RPi, remove <tt>ARCH=arm CROSS_COMPILE=<your_compiler></tt> from each command.
 +
 
 +
Ensure that your configuration file is up-to-date:
 +
<pre>
 +
make ARCH=arm CROSS_COMPILE=<your_compiler> oldconfig
 +
</pre>
 +
If any configuration options have been added, you will be asked what set each option to. If you don't know the answer, just press enter to accept the default.
 +
 
 +
Optionally, if you want to make changes to the configuration, run this next:
 +
<pre>
 +
make ARCH=arm CROSS_COMPILE=<your_compiler> menuconfig
 +
</pre>
 +
 
 +
Now you are ready to build:
 +
<pre>
 +
make ARCH=arm CROSS_COMPILE=<your_compiler>
 +
</pre>
 +
If you are on a multi-core system, you can make the build faster by appending <tt>-j<N></tt> where <tt>N</tt> is the number of cores on your system plus one.
 +
 
 +
Find something else to get on with while the compilation takes place. On an average PC with the default configuration, this should take about 15 minutes.
 +
 
 +
= Prepare the image file =
 +
Because of the way the memory addresses are arranged in the Broadcom SoC, you will need to prepare the compiled image for use.
 +
 
 +
If you haven't got the tools directory from the Git repo, please do so now:
 +
<pre>
 +
git clone git://github.com/raspberrypi/tools.git
 +
</pre>
 +
or you can download a tarball from the website using [https://github.com/raspberrypi/tools/archive/master.tar.gz this link].
 +
 
 +
In the tools set, there is a folder called <tt>mkimage</tt>. Enter this directory, then run the following:
 +
<pre>
 +
./imagetool-uncompressed.py <your_kernel_build_directory>/arch/arm/boot/zImage
 +
</pre>
 +
 
 +
This will output a file called <tt>kernel.img</tt>.
 +
 
 +
= Transfer the build =
 +
Copy your new <tt>kernel.img</tt> file into the RPi boot partition, though preferably as a new file (such as <tt>kernel_new.img</tt>) just in case it doesn't work. If you're building on the RPi, just copy the file to <tt>/boot</tt>. If you use a different filename, edit <tt>config.txt</tt> change the kernel line:
 +
<pre>
 +
kernel=kernel_new.img
 +
#kernel=kernel.img
 +
</pre>
 +
 
 +
Now you need to transfer the modules. In the build directory, run the following (substituting <tt><modules_path></tt> for a folder somewhere (e.g. <tt>~/modules</tt>):
 +
<pre>
 +
ARCH=arm CROSS_COMPILE=<your_compiler> make modules_install INSTALL_MOD_PATH=<modules_path>
 +
</pre>
 +
 
 +
The contents of this directory should then be copied into the RPi root directory. NOTE: If you have rebuilt the new kernel with exactly the same version as the one that's running, you'll need to remove the old modules first. Ideally this should be done offline by mounting the SD card on another system.
 +
 
 +
Your RPi should now be ready to boot the new kernel. However, at this point it's recommended that you update your GPU firmware and libraries. '''This is required if you've just moved from 3.2 to 3.6 as the firmware interface has changed'''.
 +
 
 +
= Get the firmware =
 +
The firmware and boot files should be updated at the same time to ensure that your new kernel works properly. Again, two branches are available:
 +
* '''master''' - This is the version of firmware currently used in Raspbian (i.e. it works with the 3.2 kernel).
 +
* '''next''' - This is a development branch which provides a newer GPU firmware to work with the updated drivers in the 3.6 kernel.
 +
 
 +
You can either download the source directly using git:
 +
You can download the firmware directly using git. For the master branch:
 +
<pre>
 +
git clone git://github.com/raspberrypi/firmware.git
 +
</pre>
 +
and for the next branch:
 +
<pre>
 +
git fetch git://github.com/raspberrypi/firmware.git next:refs/remotes/origin/next
 +
</pre>
 +
Or you can download a tarball from the website using these links: [https://github.com/raspberrypi/firmware/archive/master.tar.gz master] [https://github.com/raspberrypi/firmware/archive/next.tar.gz next]
 +
 
 +
= Transfer the firmware =
 +
Firstly, update the required boot files in the RPi <tt>boot</tt> directory with those you've downloaded. These are:
 +
* bootcode.bin
 +
* fixup.dat
 +
* start.elf
 +
 
 +
Next, you need to copy the VC libraries over. There are two copies of this: one for hard float and one for soft float. To find the correct one, run the following command (substituting the program name for your compiler binary as required):
 +
<pre>
 +
arm-none-linux-gnueabi-gcc -v 2>&1 | grep hard
 +
</pre>
 +
 
 +
If something prints out, and you can see <tt>--with-float=hard</tt>, you need the hard float ones. NOTE: The current version of Raspbian uses hard float.
 +
 
 +
Remove the <tt>/opt/vc</tt> directory from the RPi root, then:
 +
* For hard float, copy <tt>vc</tt> from the <tt>hardfp/opt</tt> directory into <tt>/opt</tt> in the RPi root directory
 +
* Otherwise copy <tt>vc</tt> from the top-level <tt>opt</tt> directory into <tt>/opt</tt> in the RPi root directory.
 +
 
 +
= Test your build =
 +
Power cycle your RPi and check the following:
 +
* If you have the serial port on the GPIO expander wired up, you should see the kernel booting.
 +
* The screen works - the kernel boots and you get a login prompt.
 +
* The VC interface is working - if the 'OK' LED flashes regularly eight or so times every few seconds once the OS has booted, it's not. You can also test this by running <tt>vcgencmd measure_temp</tt>. If it prints "VCHI initialization failed", you have the a mismatch between the firmware, the VC libraries, and the kernel driver.
 +
* Run <tt>uname -a</tt> and check that your new kernel is the one that's running.
 +
* Make sure you don't have any odd error messages during boot that may indicate a module isn't working properly. If you see <tt>missed completion of cmd 18</tt> regarding DMA transfers to the SD card, you can safely ignore it.
 +
 
 
{{Template:Raspberry Pi}}
 
{{Template:Raspberry Pi}}
 
[[Category:RaspberryPi]]
 
[[Category:RaspberryPi]]

Revision as of 12:03, 5 December 2012

Back to the Hub.


Software & Distributions:

Software - an overview.

Distributions - operating systems and development environments for the Raspberry Pi.

Kernel Compilation - advice on compiling a kernel.

Performance - measures of the Raspberry Pi's performance.

Programming - programming languages that might be used on the Raspberry Pi.

Overview

This page explains how to rebuild the kernel image for the RPi. There are two possible routes available:

  1. Compile on the Raspberry Pi itself
  2. Cross compile on another Linux system

Both of these routes are covered below, however, you are strongly recommended to follow the cross compilation route. The low processing power of the RPi means that a local compile will take many hours.

Get the kernel source

The kernel source should be downloaded from the RPI linux section on GitHub. Although you could just compile the vanilla kernel from Kernel.org, it will not have the necessary drivers and modules for the Broadcom SoC on the RPi. You can however apply patches from the vanilla kernel to the RPi one - be prepared for potential compiler grumbles though!

At the time of writing, two branches of interest are available:

  • rpi-3.2.27 - This is the version of the kernel currently used in Raspbian.
  • rpi-3.6-y - This is a development branch based on the current vanilla kernel. It will eventually replace the 3.2 branch.

You can download the source directly using git. For the 3.2 branch:

git clone git://github.com/raspberrypi/linux.git

and for the 3.6 branch:

git fetch git://github.com/raspberrypi/linux.git rpi-3.6.y:refs/remotes/origin/rpi-3.6.y
git checkout rpi-3.6.y

Or you can download a tarball from the website using these links: rpi-3.2.27 rpi-3.6.y

Get a compiler

Next, you will need to get a version of GCC in order to build the kernel.

On the RPi

Raspbian

apt-get update
apt-get -y dist-upgrade
apt-get -y install gcc make

Arch Linux

pacman -Syu
pacman -S gcc make

Cross compiling from Linux

Please note that when cross-compiling, your compiler may not target the correct ARM processor by default. This will at best reduce performance, or worse, compile for a much newer processor resulting in illegal instructions in your code. The pre-built compiler or a custom-built compiler are recommended because of this. (For example, the latest GCC Linaro binary targets armv7-a by default, whereas the RPi requires armv6kz). It is possible to add extra compiler options to the HOSTCFLAGS line in Makefile. The correct flags are shown on the software page - note that you may also need to add -marm if your compiler produces Thumb code by default.

Use the provided compiler

Download the pre-built bmc2708 compiler from the RPI tools section on GitHub.

git clone git://github.com/raspberrypi/tools.git

or you can download a tarball from the website using this link.

Custom-built Linaro GCC

See Linaro GCC Compilation.

Ubuntu

apt-get install gcc-arm-linux-gnueabi make ncurses-dev

Gentoo Linux

crossdev -S -v -t arm-unknown-linux-gnueabi

Crossdev should create a cross-toolchain using the latest stable versions of the required packages. If it fails, you can specify exact versions by removing the "-S" flag and adding the "--b", "--g", "--k" and "--l" flags. On 2012-05-06, cross -S -v -A gnueabi arm works just fine.

Arch Linux

yaourt -S arm-linux-gnueabi-gcc

Cross compiling from OSX

Macports

The Kernel source requires a case-sensitive filesystem. If you do not have a HFS+ Case-sensitive partition that can be used, create a disk image with the appropriate format. Ensure latest Xcode and command line tools are installed from Apple Developer Connection Install macports

port install arm-none-eabi-gcc
port install arm-none-eabi-binutils

If you get an error message that elf.h is missing

sudo port install libelf && sudo ln -s /opt/local/include/libelf /usr/include/libelf

From opensource.apple.com, download and copy elf.h and elftypes.h to /usr/include

Edit elf.h and add

#define R_386_NONE        0
#define R_386_32          1
#define R_386_PC32        2
#define R_ARM_NONE        0
#define R_ARM_PC24        1
#define R_ARM_ABS32       2
#define R_MIPS_NONE       0
#define R_MIPS_16         1
#define R_MIPS_32         2
#define R_MIPS_REL32      3
#define R_MIPS_26         4
#define R_MIPS_HI16       5
#define R_MIPS_LO16       6

If you get a "SEGMENT_SIZE is undeclared" error open the Makefile and change the line:

NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include)

to

NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include) -Dlinux

Yagarto

Download and install from here.

Perform the compilation

Firstly, ensure your build directory is clean:

make mrproper

Next, in all cases, you will want to get a working kernel configuration to start from. You can get the one running on the RPi by typing the following (on the RPi):

zcat /proc/config.gz > .config

then copy .config into your build directory.

Alternatively, the default configuration is available in the downloaded kernel source in arch/arm/configs/bcmrpi_defconfig. Just copy this to .config in the build directory.

From this point on, if you are cross-compiling, please substitute <your_compiler> with your compiler binary prefix (e.g. arm-bcm2708hardfp-linux-gnueabi-) as each compiler will be named slightly differently. If you are building on the RPi, remove ARCH=arm CROSS_COMPILE=<your_compiler> from each command.

Ensure that your configuration file is up-to-date:

make ARCH=arm CROSS_COMPILE=<your_compiler> oldconfig

If any configuration options have been added, you will be asked what set each option to. If you don't know the answer, just press enter to accept the default.

Optionally, if you want to make changes to the configuration, run this next:

make ARCH=arm CROSS_COMPILE=<your_compiler> menuconfig

Now you are ready to build:

make ARCH=arm CROSS_COMPILE=<your_compiler>

If you are on a multi-core system, you can make the build faster by appending -j<N> where N is the number of cores on your system plus one.

Find something else to get on with while the compilation takes place. On an average PC with the default configuration, this should take about 15 minutes.

Prepare the image file

Because of the way the memory addresses are arranged in the Broadcom SoC, you will need to prepare the compiled image for use.

If you haven't got the tools directory from the Git repo, please do so now:

git clone git://github.com/raspberrypi/tools.git

or you can download a tarball from the website using this link.

In the tools set, there is a folder called mkimage. Enter this directory, then run the following:

./imagetool-uncompressed.py <your_kernel_build_directory>/arch/arm/boot/zImage

This will output a file called kernel.img.

Transfer the build

Copy your new kernel.img file into the RPi boot partition, though preferably as a new file (such as kernel_new.img) just in case it doesn't work. If you're building on the RPi, just copy the file to /boot. If you use a different filename, edit config.txt change the kernel line:

kernel=kernel_new.img
#kernel=kernel.img

Now you need to transfer the modules. In the build directory, run the following (substituting <modules_path> for a folder somewhere (e.g. ~/modules):

ARCH=arm CROSS_COMPILE=<your_compiler> make modules_install INSTALL_MOD_PATH=<modules_path>

The contents of this directory should then be copied into the RPi root directory. NOTE: If you have rebuilt the new kernel with exactly the same version as the one that's running, you'll need to remove the old modules first. Ideally this should be done offline by mounting the SD card on another system.

Your RPi should now be ready to boot the new kernel. However, at this point it's recommended that you update your GPU firmware and libraries. This is required if you've just moved from 3.2 to 3.6 as the firmware interface has changed.

Get the firmware

The firmware and boot files should be updated at the same time to ensure that your new kernel works properly. Again, two branches are available:

  • master - This is the version of firmware currently used in Raspbian (i.e. it works with the 3.2 kernel).
  • next - This is a development branch which provides a newer GPU firmware to work with the updated drivers in the 3.6 kernel.

You can either download the source directly using git: You can download the firmware directly using git. For the master branch:

git clone git://github.com/raspberrypi/firmware.git

and for the next branch:

git fetch git://github.com/raspberrypi/firmware.git next:refs/remotes/origin/next

Or you can download a tarball from the website using these links: master next

Transfer the firmware

Firstly, update the required boot files in the RPi boot directory with those you've downloaded. These are:

  • bootcode.bin
  • fixup.dat
  • start.elf

Next, you need to copy the VC libraries over. There are two copies of this: one for hard float and one for soft float. To find the correct one, run the following command (substituting the program name for your compiler binary as required):

arm-none-linux-gnueabi-gcc -v 2>&1 | grep hard

If something prints out, and you can see --with-float=hard, you need the hard float ones. NOTE: The current version of Raspbian uses hard float.

Remove the /opt/vc directory from the RPi root, then:

  • For hard float, copy vc from the hardfp/opt directory into /opt in the RPi root directory
  • Otherwise copy vc from the top-level opt directory into /opt in the RPi root directory.

Test your build

Power cycle your RPi and check the following:

  • If you have the serial port on the GPIO expander wired up, you should see the kernel booting.
  • The screen works - the kernel boots and you get a login prompt.
  • The VC interface is working - if the 'OK' LED flashes regularly eight or so times every few seconds once the OS has booted, it's not. You can also test this by running vcgencmd measure_temp. If it prints "VCHI initialization failed", you have the a mismatch between the firmware, the VC libraries, and the kernel driver.
  • Run uname -a and check that your new kernel is the one that's running.
  • Make sure you don't have any odd error messages during boot that may indicate a module isn't working properly. If you see missed completion of cmd 18 regarding DMA transfers to the SD card, you can safely ignore it.